Index: squid/lib/dlmalloc.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/dlmalloc.c,v
retrieving revision 1.1.1.1.44.2
retrieving revision 1.1.1.1.44.2.2.1
diff -u -r1.1.1.1.44.2 -r1.1.1.1.44.2.2.1
--- squid/lib/dlmalloc.c	14 Jun 2001 21:34:24 -0000	1.1.1.1.44.2
+++ squid/lib/dlmalloc.c	27 Aug 2001 21:48:17 -0000	1.1.1.1.44.2.2.1
@@ -1730,79 +1719,84 @@
 #if __STD_C
 static mchunkptr mmap_chunk(size_t size)
 #else
-static mchunkptr mmap_chunk(size) size_t size;
+static mchunkptr mmap_chunk(size)
+     size_t size;
 #endif
 {
-  size_t page_mask = malloc_getpagesize - 1;
-  mchunkptr p;
+    size_t page_mask = malloc_getpagesize - 1;
+    mchunkptr p;
 
 #ifndef MAP_ANONYMOUS
-  static int fd = -1;
+    static int fd = -1;
 #endif
 
-  if(n_mmaps >= n_mmaps_max) return 0; /* too many regions */
+    if (n_mmaps >= n_mmaps_max)
+	return 0;		/* too many regions */
 
-  /* For mmapped chunks, the overhead is one SIZE_SZ unit larger, because
-   * there is no following chunk whose prev_size field could be used.
-   */
-  size = (size + SIZE_SZ + page_mask) & ~page_mask;
+    /* For mmapped chunks, the overhead is one SIZE_SZ unit larger, because
+     * there is no following chunk whose prev_size field could be used.
+     */
+    size = (size + SIZE_SZ + page_mask) & ~page_mask;
 
 #ifdef MAP_ANONYMOUS
-  p = (mchunkptr)mmap(0, size, PROT_READ|PROT_WRITE,
-		      MAP_PRIVATE|MAP_ANONYMOUS, -1, 0);
+    p = (mchunkptr) mmap(0, size, PROT_READ | PROT_WRITE,
+	MAP_PRIVATE | MAP_ANONYMOUS, -1, 0);
 #else /* !MAP_ANONYMOUS */
-  if (fd < 0) 
-  {
-    fd = open("/dev/zero", O_RDWR);
-    if(fd < 0) return 0;
-  }
-  p = (mchunkptr)mmap(0, size, PROT_READ|PROT_WRITE, MAP_PRIVATE, fd, 0);
+    if (fd < 0) {
+	fd = open("/dev/zero", O_RDWR);
+	if (fd < 0)
+	    return 0;
+    }
+    p = (mchunkptr) mmap(0, size, PROT_READ | PROT_WRITE, MAP_PRIVATE, fd, 0);
 #endif
 
-  if(p == (mchunkptr)-1) return 0;
+    if (p == (mchunkptr) - 1)
+	return 0;
 
-  n_mmaps++;
-  if (n_mmaps > max_n_mmaps) max_n_mmaps = n_mmaps;
-  
-  /* We demand that eight bytes into a page must be 8-byte aligned. */
-  assert(aligned_OK(chunk2mem(p)));
+    n_mmaps++;
+    if (n_mmaps > max_n_mmaps)
+	max_n_mmaps = n_mmaps;
 
-  /* The offset to the start of the mmapped region is stored
-   * in the prev_size field of the chunk; normally it is zero,
-   * but that can be changed in memalign().
-   */
-  p->prev_size = 0;
-  set_head(p, size|IS_MMAPPED);
-  
-  mmapped_mem += size;
-  if ((unsigned long)mmapped_mem > (unsigned long)max_mmapped_mem) 
-    max_mmapped_mem = mmapped_mem;
-  if ((unsigned long)(mmapped_mem + sbrked_mem) > (unsigned long)max_total_mem) 
-    max_total_mem = mmapped_mem + sbrked_mem;
-  return p;
+    /* We demand that eight bytes into a page must be 8-byte aligned. */
+    assert(aligned_OK(chunk2mem(p)));
+
+    /* The offset to the start of the mmapped region is stored
+     * in the prev_size field of the chunk; normally it is zero,
+     * but that can be changed in memalign().
+     */
+    p->prev_size = 0;
+    set_head(p, size | IS_MMAPPED);
+
+    mmapped_mem += size;
+    if ((unsigned long) mmapped_mem > (unsigned long) max_mmapped_mem)
+	max_mmapped_mem = mmapped_mem;
+    if ((unsigned long) (mmapped_mem + sbrked_mem) >
+	(unsigned long) max_total_mem) max_total_mem = mmapped_mem + sbrked_mem;
+    return p;
 }
 
 #if __STD_C
 static void munmap_chunk(mchunkptr p)
 #else
-static void munmap_chunk(p) mchunkptr p;
+static void munmap_chunk(p)
+     mchunkptr p;
 #endif
 {
-  INTERNAL_SIZE_T size = chunksize(p);
-  int ret;
+    INTERNAL_SIZE_T size = chunksize(p);
+    int ret;
 
-  assert (chunk_is_mmapped(p));
-  assert(! ((char*)p >= sbrk_base && (char*)p < sbrk_base + sbrked_mem));
-  assert((n_mmaps > 0));
-  assert(((p->prev_size + size) & (malloc_getpagesize-1)) == 0);
+    assert(chunk_is_mmapped(p));
+    assert(!((char *) p >= sbrk_base && (char *) p < sbrk_base + sbrked_mem));
+    assert((n_mmaps > 0));
+    assert(((p->prev_size + size) & (malloc_getpagesize - 1)) == 0);
 
-  n_mmaps--;
-  mmapped_mem -= (size + p->prev_size);
+    n_mmaps--;
+    mmapped_mem -= (size + p->prev_size);
 
-  ret = munmap((char *)p - p->prev_size, size + p->prev_size);
+    ret = munmap((char *) p - p->prev_size, size + p->prev_size);
 
-  /* munmap returns non-zero on failure */
-  assert(ret == 0);
+    /* munmap returns non-zero on failure */
+    assert(ret == 0);
 }
 
 #if HAVE_MREMAP
@@ -1810,48 +1804,51 @@
 #if __STD_C
 static mchunkptr mremap_chunk(mchunkptr p, size_t new_size)
 #else
-static mchunkptr mremap_chunk(p, new_size) mchunkptr p; size_t new_size;
+static mchunkptr mremap_chunk(p, new_size)
+     mchunkptr p;
+     size_t new_size;
 #endif
 {
-  size_t page_mask = malloc_getpagesize - 1;
-  INTERNAL_SIZE_T offset = p->prev_size;
-  INTERNAL_SIZE_T size = chunksize(p);
-  char *cp;
+    size_t page_mask = malloc_getpagesize - 1;
+    INTERNAL_SIZE_T offset = p->prev_size;
+    INTERNAL_SIZE_T size = chunksize(p);
+    char *cp;
 
-  assert (chunk_is_mmapped(p));
-  assert(! ((char*)p >= sbrk_base && (char*)p < sbrk_base + sbrked_mem));
-  assert((n_mmaps > 0));
-  assert(((size + offset) & (malloc_getpagesize-1)) == 0);
+    assert(chunk_is_mmapped(p));
+    assert(!((char *) p >= sbrk_base && (char *) p < sbrk_base + sbrked_mem));
+    assert((n_mmaps > 0));
+    assert(((size + offset) & (malloc_getpagesize - 1)) == 0);
 
-  /* Note the extra SIZE_SZ overhead as in mmap_chunk(). */
-  new_size = (new_size + offset + SIZE_SZ + page_mask) & ~page_mask;
+    /* Note the extra SIZE_SZ overhead as in mmap_chunk(). */
+    new_size = (new_size + offset + SIZE_SZ + page_mask) & ~page_mask;
 
-  cp = (char *)mremap((char *)p - offset, size + offset, new_size, 1);
+    cp = (char *) mremap((char *) p - offset, size + offset, new_size, 1);
 
-  if (cp == (char *)-1) return 0;
+    if (cp == (char *) -1)
+	return 0;
 
-  p = (mchunkptr)(cp + offset);
+    p = (mchunkptr) (cp + offset);
 
-  assert(aligned_OK(chunk2mem(p)));
+    assert(aligned_OK(chunk2mem(p)));
 
-  assert((p->prev_size == offset));
-  set_head(p, (new_size - offset)|IS_MMAPPED);
+    assert((p->prev_size == offset));
+    set_head(p, (new_size - offset) | IS_MMAPPED);
 
-  mmapped_mem -= size + offset;
-  mmapped_mem += new_size;
-  if ((unsigned long)mmapped_mem > (unsigned long)max_mmapped_mem) 
-    max_mmapped_mem = mmapped_mem;
-  if ((unsigned long)(mmapped_mem + sbrked_mem) > (unsigned long)max_total_mem)
-    max_total_mem = mmapped_mem + sbrked_mem;
-  return p;
+    mmapped_mem -= size + offset;
+    mmapped_mem += new_size;
+    if ((unsigned long) mmapped_mem > (unsigned long) max_mmapped_mem)
+	max_mmapped_mem = mmapped_mem;
+    if ((unsigned long) (mmapped_mem + sbrked_mem) >
+	(unsigned long) max_total_mem) max_total_mem = mmapped_mem + sbrked_mem;
+    return p;
 }
 
 #endif /* HAVE_MREMAP */
 
 #endif /* HAVE_MMAP */
+
 
 
-
 
 /* 
   Extend the top-most chunk by obtaining memory from system.
@@ -1861,112 +1858,106 @@
 #if __STD_C
 static void malloc_extend_top(INTERNAL_SIZE_T nb)
 #else
-static void malloc_extend_top(nb) INTERNAL_SIZE_T nb;
+static void malloc_extend_top(nb)
+     INTERNAL_SIZE_T nb;
 #endif
 {
-  char*     brk;                  /* return value from sbrk */
-  INTERNAL_SIZE_T front_misalign; /* unusable bytes at front of sbrked space */
-  INTERNAL_SIZE_T correction;     /* bytes for 2nd sbrk call */
-  char*     new_brk;              /* return of 2nd sbrk call */
-  INTERNAL_SIZE_T top_size;       /* new size of top chunk */
-
-  mchunkptr old_top     = top;  /* Record state of old top */
-  INTERNAL_SIZE_T old_top_size = chunksize(old_top);
-  char*     old_end      = (char*)(chunk_at_offset(old_top, old_top_size));
-
-  /* Pad request with top_pad plus minimal overhead */
-  
-  INTERNAL_SIZE_T    sbrk_size     = nb + top_pad + MINSIZE;
-  unsigned long pagesz    = malloc_getpagesize;
-
-  /* If not the first time through, round to preserve page boundary */
-  /* Otherwise, we need to correct to a page size below anyway. */
-  /* (We also correct below if an intervening foreign sbrk call.) */
-
-  if (sbrk_base != (char*)(-1))
-    sbrk_size = (sbrk_size + (pagesz - 1)) & ~(pagesz - 1);
-
-  brk = (char*)(MORECORE (sbrk_size));
-
-  /* Fail if sbrk failed or if a foreign sbrk call killed our space */
-  if (brk == (char*)(MORECORE_FAILURE) || 
-      (brk < old_end && old_top != initial_top))
-    return;     
-
-  sbrked_mem += sbrk_size;
-
-  if (brk == old_end) /* can just add bytes to current top */
-  {
-    top_size = sbrk_size + old_top_size;
-    set_head(top, top_size | PREV_INUSE);
-  }
-  else
-  {
-    if (sbrk_base == (char*)(-1))  /* First time through. Record base */
-      sbrk_base = brk;
-    else  /* Someone else called sbrk().  Count those bytes as sbrked_mem. */
-      sbrked_mem += brk - (char*)old_end;
-
-    /* Guarantee alignment of first new chunk made from this space */
-    front_misalign = (unsigned long)chunk2mem(brk) & MALLOC_ALIGN_MASK;
-    if (front_misalign > 0) 
-    {
-      correction = (MALLOC_ALIGNMENT) - front_misalign;
-      brk += correction;
+    char *brk;			/* return value from sbrk */
+    INTERNAL_SIZE_T front_misalign;	/* unusable bytes at front of sbrked space */
+    INTERNAL_SIZE_T correction;	/* bytes for 2nd sbrk call */
+    char *new_brk;		/* return of 2nd sbrk call */
+    INTERNAL_SIZE_T top_size;	/* new size of top chunk */
+
+    mchunkptr old_top = top;	/* Record state of old top */
+    INTERNAL_SIZE_T old_top_size = chunksize(old_top);
+    char *old_end = (char *) (chunk_at_offset(old_top, old_top_size));
+
+    /* Pad request with top_pad plus minimal overhead */
+
+    INTERNAL_SIZE_T sbrk_size = nb + top_pad + MINSIZE;
+    unsigned long pagesz = malloc_getpagesize;
+
+    /* If not the first time through, round to preserve page boundary */
+    /* Otherwise, we need to correct to a page size below anyway. */
+    /* (We also correct below if an intervening foreign sbrk call.) */
+
+    if (sbrk_base != (char *) (-1))
+	sbrk_size = (sbrk_size + (pagesz - 1)) & ~(pagesz - 1);
+
+    brk = (char *) (MORECORE(sbrk_size));
+
+    /* Fail if sbrk failed or if a foreign sbrk call killed our space */
+    if (brk == (char *) (MORECORE_FAILURE) ||
+	(brk < old_end && old_top != initial_top)) return;
+
+    sbrked_mem += sbrk_size;
+
+    if (brk == old_end) {	/* can just add bytes to current top */
+	top_size = sbrk_size + old_top_size;
+	set_head(top, top_size | PREV_INUSE);
+    } else {
+	if (sbrk_base == (char *) (-1))	/* First time through. Record base */
+	    sbrk_base = brk;
+	else			/* Someone else called sbrk().  Count those bytes as sbrked_mem. */
+	    sbrked_mem += brk - (char *) old_end;
+
+	/* Guarantee alignment of first new chunk made from this space */
+	front_misalign = (unsigned long) chunk2mem(brk) & MALLOC_ALIGN_MASK;
+	if (front_misalign > 0) {
+	    correction = (MALLOC_ALIGNMENT) - front_misalign;
+	    brk += correction;
+	} else
+	    correction = 0;
+
+	/* Guarantee the next brk will be at a page boundary */
+	correction +=
+	    pagesz - ((unsigned long) (brk + sbrk_size) & (pagesz - 1));
+
+	/* Allocate correction */
+	new_brk = (char *) (MORECORE(correction));
+	if (new_brk == (char *) (MORECORE_FAILURE))
+	    return;
+
+	sbrked_mem += correction;
+
+	top = (mchunkptr) brk;
+	top_size = new_brk - brk + correction;
+	set_head(top, top_size | PREV_INUSE);
+
+	if (old_top != initial_top) {
+
+	    /* There must have been an intervening foreign sbrk call. */
+	    /* A double fencepost is necessary to prevent consolidation */
+
+	    /* If not enough space to do this, then user did something very wrong */
+	    if (old_top_size < MINSIZE) {
+		set_head(top, PREV_INUSE);	/* will force null return from malloc */
+		return;
+	    }
+
+	    /* Also keep size a multiple of MALLOC_ALIGNMENT */
+	    old_top_size = (old_top_size - 3 * SIZE_SZ) & ~MALLOC_ALIGN_MASK;
+	    chunk_at_offset(old_top, old_top_size)->size = SIZE_SZ | PREV_INUSE;
+	    chunk_at_offset(old_top, old_top_size + SIZE_SZ)->size =
+		SIZE_SZ | PREV_INUSE;
+	    set_head_size(old_top, old_top_size);
+	    /* If possible, release the rest. */
+	    if (old_top_size >= MINSIZE)
+		fREe(chunk2mem(old_top));
+	}
     }
-    else
-      correction = 0;
-
-    /* Guarantee the next brk will be at a page boundary */
-    correction += pagesz - ((unsigned long)(brk + sbrk_size) & (pagesz - 1));
 
-    /* Allocate correction */
-    new_brk = (char*)(MORECORE (correction));
-    if (new_brk == (char*)(MORECORE_FAILURE)) return; 
-
-    sbrked_mem += correction;
-
-    top = (mchunkptr)brk;
-    top_size = new_brk - brk + correction;
-    set_head(top, top_size | PREV_INUSE);
-
-    if (old_top != initial_top)
-    {
+    if ((unsigned long) sbrked_mem > (unsigned long) max_sbrked_mem)
+	max_sbrked_mem = sbrked_mem;
+    if ((unsigned long) (mmapped_mem + sbrked_mem) >
+	(unsigned long) max_total_mem) max_total_mem = mmapped_mem + sbrked_mem;
 
-      /* There must have been an intervening foreign sbrk call. */
-      /* A double fencepost is necessary to prevent consolidation */
-
-      /* If not enough space to do this, then user did something very wrong */
-      if (old_top_size < MINSIZE) 
-      {
-        set_head(top, PREV_INUSE); /* will force null return from malloc */
-        return;
-      }
-
-      /* Also keep size a multiple of MALLOC_ALIGNMENT */
-      old_top_size = (old_top_size - 3*SIZE_SZ) & ~MALLOC_ALIGN_MASK;
-      chunk_at_offset(old_top, old_top_size          )->size =
-        SIZE_SZ|PREV_INUSE;
-      chunk_at_offset(old_top, old_top_size + SIZE_SZ)->size =
-        SIZE_SZ|PREV_INUSE;
-      set_head_size(old_top, old_top_size);
-      /* If possible, release the rest. */
-      if (old_top_size >= MINSIZE) 
-        fREe(chunk2mem(old_top));
-    }
-  }
-
-  if ((unsigned long)sbrked_mem > (unsigned long)max_sbrked_mem) 
-    max_sbrked_mem = sbrked_mem;
-  if ((unsigned long)(mmapped_mem + sbrked_mem) > (unsigned long)max_total_mem) 
-    max_total_mem = mmapped_mem + sbrked_mem;
-
-  /* We always land on a page boundary */
-  assert(((unsigned long)((char*)top + top_size) & (pagesz - 1)) == 0);
+    /* We always land on a page boundary */
+    assert(((unsigned long) ((char *) top + top_size) & (pagesz - 1)) == 0);
 }
+
 
 
-
 
 /* Main public routines */
 
@@ -2031,240 +2022,216 @@
 */
 
 #if __STD_C
-Void_t* mALLOc(size_t bytes)
+Void_t *mALLOc(size_t bytes)
 #else
-Void_t* mALLOc(bytes) size_t bytes;
+Void_t *mALLOc(bytes)
+     size_t bytes;
 #endif
 {
-  mchunkptr victim;                  /* inspected/selected chunk */
-  INTERNAL_SIZE_T victim_size;       /* its size */
-  int       idx;                     /* index for bin traversal */
-  mbinptr   bin;                     /* associated bin */
-  mchunkptr remainder;               /* remainder from a split */
-  long      remainder_size;          /* its size */
-  int       remainder_index;         /* its bin index */
-  unsigned long block;               /* block traverser bit */
-  int       startidx;                /* first bin of a traversed block */
-  mchunkptr fwd;                     /* misc temp for linking */
-  mchunkptr bck;                     /* misc temp for linking */
-  mbinptr q;                         /* misc temp */
+    mchunkptr victim;		/* inspected/selected chunk */
+    INTERNAL_SIZE_T victim_size;	/* its size */
+    int idx;			/* index for bin traversal */
+    mbinptr bin;		/* associated bin */
+    mchunkptr remainder;	/* remainder from a split */
+    long remainder_size;	/* its size */
+    int remainder_index;	/* its bin index */
+    unsigned long block;	/* block traverser bit */
+    int startidx;		/* first bin of a traversed block */
+    mchunkptr fwd;		/* misc temp for linking */
+    mchunkptr bck;		/* misc temp for linking */
+    mbinptr q;			/* misc temp */
 
-  INTERNAL_SIZE_T nb  = request2size(bytes);  /* padded request size; */
+    INTERNAL_SIZE_T nb = request2size(bytes);	/* padded request size; */
 
-  /* Check for exact match in a bin */
+    /* Check for exact match in a bin */
 
-  if (is_small_request(nb))  /* Faster version for small requests */
-  {
-    idx = smallbin_index(nb); 
+    if (is_small_request(nb)) {	/* Faster version for small requests */
+	idx = smallbin_index(nb);
 
-    /* No traversal or size check necessary for small bins.  */
+	/* No traversal or size check necessary for small bins.  */
 
-    q = bin_at(idx);
-    victim = last(q);
+	q = bin_at(idx);
+	victim = last(q);
 
-    /* Also scan the next one, since it would have a remainder < MINSIZE */
-    if (victim == q)
-    {
-      q = next_bin(q);
-      victim = last(q);
-    }
-    if (victim != q)
-    {
-      victim_size = chunksize(victim);
-      unlink(victim, bck, fwd);
-      set_inuse_bit_at_offset(victim, victim_size);
-      check_malloced_chunk(victim, nb);
-      return chunk2mem(victim);
-    }
-
-    idx += 2; /* Set for bin scan below. We've already scanned 2 bins. */
-
-  }
-  else
-  {
-    idx = bin_index(nb);
-    bin = bin_at(idx);
+	/* Also scan the next one, since it would have a remainder < MINSIZE */
+	if (victim == q) {
+	    q = next_bin(q);
+	    victim = last(q);
+	}
+	if (victim != q) {
+	    victim_size = chunksize(victim);
+	    unlink(victim, bck, fwd);
+	    set_inuse_bit_at_offset(victim, victim_size);
+	    check_malloced_chunk(victim, nb);
+	    return chunk2mem(victim);
+	}
 
-    for (victim = last(bin); victim != bin; victim = victim->bk)
-    {
-      victim_size = chunksize(victim);
-      remainder_size = victim_size - nb;
-      
-      if (remainder_size >= (long)MINSIZE) /* too big */
-      {
-        --idx; /* adjust to rescan below after checking last remainder */
-        break;   
-      }
-
-      else if (remainder_size >= 0) /* exact fit */
-      {
-        unlink(victim, bck, fwd);
-        set_inuse_bit_at_offset(victim, victim_size);
-        check_malloced_chunk(victim, nb);
-        return chunk2mem(victim);
-      }
-    }
-
-    ++idx; 
-
-  }
-
-  /* Try to use the last split-off remainder */
-
-  if ( (victim = last_remainder->fd) != last_remainder)
-  {
-    victim_size = chunksize(victim);
-    remainder_size = victim_size - nb;
+	idx += 2;		/* Set for bin scan below. We've already scanned 2 bins. */
+
+    } else {
+	idx = bin_index(nb);
+	bin = bin_at(idx);
+
+	for (victim = last(bin); victim != bin; victim = victim->bk) {
+	    victim_size = chunksize(victim);
+	    remainder_size = victim_size - nb;
+
+	    if (remainder_size >= (long) MINSIZE) {	/* too big */
+		--idx;		/* adjust to rescan below after checking last remainder */
+		break;
+	    }
+
+	    else if (remainder_size >= 0) {	/* exact fit */
+		unlink(victim, bck, fwd);
+		set_inuse_bit_at_offset(victim, victim_size);
+		check_malloced_chunk(victim, nb);
+		return chunk2mem(victim);
+	    }
+	}
+
+	++idx;
 
-    if (remainder_size >= (long)MINSIZE) /* re-split */
-    {
-      remainder = chunk_at_offset(victim, nb);
-      set_head(victim, nb | PREV_INUSE);
-      link_last_remainder(remainder);
-      set_head(remainder, remainder_size | PREV_INUSE);
-      set_foot(remainder, remainder_size);
-      check_malloced_chunk(victim, nb);
-      return chunk2mem(victim);
     }
 
-    clear_last_remainder;
+    /* Try to use the last split-off remainder */
 
-    if (remainder_size >= 0)  /* exhaust */
-    {
-      set_inuse_bit_at_offset(victim, victim_size);
-      check_malloced_chunk(victim, nb);
-      return chunk2mem(victim);
+    if ((victim = last_remainder->fd) != last_remainder) {
+	victim_size = chunksize(victim);
+	remainder_size = victim_size - nb;
+
+	if (remainder_size >= (long) MINSIZE) {	/* re-split */
+	    remainder = chunk_at_offset(victim, nb);
+	    set_head(victim, nb | PREV_INUSE);
+	    link_last_remainder(remainder);
+	    set_head(remainder, remainder_size | PREV_INUSE);
+	    set_foot(remainder, remainder_size);
+	    check_malloced_chunk(victim, nb);
+	    return chunk2mem(victim);
+	}
+
+	clear_last_remainder;
+
+	if (remainder_size >= 0) {	/* exhaust */
+	    set_inuse_bit_at_offset(victim, victim_size);
+	    check_malloced_chunk(victim, nb);
+	    return chunk2mem(victim);
+	}
+
+	/* Else place in bin */
+
+	frontlink(victim, victim_size, remainder_index, bck, fwd);
     }
 
-    /* Else place in bin */
+    /* 
+     * If there are any possibly nonempty big-enough blocks, 
+     * search for best fitting chunk by scanning bins in blockwidth units.
+     */
+
+    if ((block = idx2binblock(idx)) <= binblocks) {
+
+	/* Get to the first marked block */
+
+	if ((block & binblocks) == 0) {
+	    /* force to an even block boundary */
+	    idx = (idx & ~(BINBLOCKWIDTH - 1)) + BINBLOCKWIDTH;
+	    block <<= 1;
+	    while ((block & binblocks) == 0) {
+		idx += BINBLOCKWIDTH;
+		block <<= 1;
+	    }
+	}
 
-    frontlink(victim, victim_size, remainder_index, bck, fwd);
-  }
+	/* For each possibly nonempty block ... */
+	for (;;) {
+	    startidx = idx;	/* (track incomplete blocks) */
+	    q = bin = bin_at(idx);
+
+	    /* For each bin in this block ... */
+	    do {
+		/* Find and use first big enough chunk ... */
+
+		for (victim = last(bin); victim != bin; victim = victim->bk) {
+		    victim_size = chunksize(victim);
+		    remainder_size = victim_size - nb;
+
+		    if (remainder_size >= (long) MINSIZE) {	/* split */
+			remainder = chunk_at_offset(victim, nb);
+			set_head(victim, nb | PREV_INUSE);
+			unlink(victim, bck, fwd);
+			link_last_remainder(remainder);
+			set_head(remainder, remainder_size | PREV_INUSE);
+			set_foot(remainder, remainder_size);
+			check_malloced_chunk(victim, nb);
+			return chunk2mem(victim);
+		    }
+
+		    else if (remainder_size >= 0) {	/* take */
+			set_inuse_bit_at_offset(victim, victim_size);
+			unlink(victim, bck, fwd);
+			check_malloced_chunk(victim, nb);
+			return chunk2mem(victim);
+		    }
 
-  /* 
-     If there are any possibly nonempty big-enough blocks, 
-     search for best fitting chunk by scanning bins in blockwidth units.
-  */
+		}
 
-  if ( (block = idx2binblock(idx)) <= binblocks)  
-  {
+		bin = next_bin(bin);
 
-    /* Get to the first marked block */
+	    } while ((++idx & (BINBLOCKWIDTH - 1)) != 0);
 
-    if ( (block & binblocks) == 0) 
-    {
-      /* force to an even block boundary */
-      idx = (idx & ~(BINBLOCKWIDTH - 1)) + BINBLOCKWIDTH;
-      block <<= 1;
-      while ((block & binblocks) == 0)
-      {
-        idx += BINBLOCKWIDTH;
-        block <<= 1;
-      }
-    }
-      
-    /* For each possibly nonempty block ... */
-    for (;;)  
-    {
-      startidx = idx;          /* (track incomplete blocks) */
-      q = bin = bin_at(idx);
+	    /* Clear out the block bit. */
 
-      /* For each bin in this block ... */
-      do
-      {
-        /* Find and use first big enough chunk ... */
-
-        for (victim = last(bin); victim != bin; victim = victim->bk)
-        {
-          victim_size = chunksize(victim);
-          remainder_size = victim_size - nb;
-
-          if (remainder_size >= (long)MINSIZE) /* split */
-          {
-            remainder = chunk_at_offset(victim, nb);
-            set_head(victim, nb | PREV_INUSE);
-            unlink(victim, bck, fwd);
-            link_last_remainder(remainder);
-            set_head(remainder, remainder_size | PREV_INUSE);
-            set_foot(remainder, remainder_size);
-            check_malloced_chunk(victim, nb);
-            return chunk2mem(victim);
-          }
-
-          else if (remainder_size >= 0)  /* take */
-          {
-            set_inuse_bit_at_offset(victim, victim_size);
-            unlink(victim, bck, fwd);
-            check_malloced_chunk(victim, nb);
-            return chunk2mem(victim);
-          }
-
-        }
-
-       bin = next_bin(bin);
-
-      } while ((++idx & (BINBLOCKWIDTH - 1)) != 0);
-
-      /* Clear out the block bit. */
-
-      do   /* Possibly backtrack to try to clear a partial block */
-      {
-        if ((startidx & (BINBLOCKWIDTH - 1)) == 0)
-        {
-          binblocks &= ~block;
-          break;
-        }
-        --startidx;
-       q = prev_bin(q);
-      } while (first(q) == q);
-
-      /* Get to the next possibly nonempty block */
-
-      if ( (block <<= 1) <= binblocks && (block != 0) ) 
-      {
-        while ((block & binblocks) == 0)
-        {
-          idx += BINBLOCKWIDTH;
-          block <<= 1;
-        }
-      }
-      else
-        break;
-    }
-  }
-
-
-  /* Try to use top chunk */
-
-  /* Require that there be a remainder, ensuring top always exists  */
-  if ( (remainder_size = chunksize(top) - nb) < (long)MINSIZE)
-  {
+	    do {		/* Possibly backtrack to try to clear a partial block */
+		if ((startidx & (BINBLOCKWIDTH - 1)) == 0) {
+		    binblocks &= ~block;
+		    break;
+		}
+		--startidx;
+		q = prev_bin(q);
+	    } while (first(q) == q);
+
+	    /* Get to the next possibly nonempty block */
+
+	    if ((block <<= 1) <= binblocks && (block != 0)) {
+		while ((block & binblocks) == 0) {
+		    idx += BINBLOCKWIDTH;
+		    block <<= 1;
+		}
+	    } else
+		break;
+	}
+    }
+
+
+    /* Try to use top chunk */
+
+    /* Require that there be a remainder, ensuring top always exists  */
+    if ((remainder_size = chunksize(top) - nb) < (long) MINSIZE) {
 
 #if HAVE_MMAP
-    /* If big and would otherwise need to extend, try to use mmap instead */
-    if ((unsigned long)nb >= (unsigned long)mmap_threshold &&
-        (victim = mmap_chunk(nb)) != 0)
-      return chunk2mem(victim);
-#endif
-
-    /* Try to extend */
-    malloc_extend_top(nb);
-    if ( (remainder_size = chunksize(top) - nb) < (long)MINSIZE)
-      return 0; /* propagate failure */
-  }
-
-  victim = top;
-  set_head(victim, nb | PREV_INUSE);
-  top = chunk_at_offset(victim, nb);
-  set_head(top, remainder_size | PREV_INUSE);
-  check_malloced_chunk(victim, nb);
-  return chunk2mem(victim);
+	/* If big and would otherwise need to extend, try to use mmap instead */
+	if ((unsigned long) nb >= (unsigned long) mmap_threshold &&
+	    (victim = mmap_chunk(nb)) != 0)
+	    return chunk2mem(victim);
+#endif
 
-}
+	/* Try to extend */
+	malloc_extend_top(nb);
+	if ((remainder_size = chunksize(top) - nb) < (long) MINSIZE)
+	    return 0;		/* propagate failure */
+    }
 
+    victim = top;
+    set_head(victim, nb | PREV_INUSE);
+    top = chunk_at_offset(victim, nb);
+    set_head(top, remainder_size | PREV_INUSE);
+    check_malloced_chunk(victim, nb);
+    return chunk2mem(victim);
 
+}
 
 
+
+
 /*
 
   free() algorithm :
@@ -2288,101 +2255,95 @@
 
 
 #if __STD_C
-void fREe(Void_t* mem)
+void fREe(Void_t * mem)
 #else
-void fREe(mem) Void_t* mem;
+void fREe(mem)
+     Void_t *mem;
 #endif
 {
-  mchunkptr p;         /* chunk corresponding to mem */
-  INTERNAL_SIZE_T hd;  /* its head field */
-  INTERNAL_SIZE_T sz;  /* its size */
-  int       idx;       /* its bin index */
-  mchunkptr next;      /* next contiguous chunk */
-  INTERNAL_SIZE_T nextsz; /* its size */
-  INTERNAL_SIZE_T prevsz; /* size of previous contiguous chunk */
-  mchunkptr bck;       /* misc temp for linking */
-  mchunkptr fwd;       /* misc temp for linking */
-  int       islr;      /* track whether merging with last_remainder */
+    mchunkptr p;		/* chunk corresponding to mem */
+    INTERNAL_SIZE_T hd;		/* its head field */
+    INTERNAL_SIZE_T sz;		/* its size */
+    int idx;			/* its bin index */
+    mchunkptr next;		/* next contiguous chunk */
+    INTERNAL_SIZE_T nextsz;	/* its size */
+    INTERNAL_SIZE_T prevsz;	/* size of previous contiguous chunk */
+    mchunkptr bck;		/* misc temp for linking */
+    mchunkptr fwd;		/* misc temp for linking */
+    int islr;			/* track whether merging with last_remainder */
 
-  if (mem == 0)                              /* free(0) has no effect */
-    return;
+    if (mem == 0)		/* free(0) has no effect */
+	return;
 
-  p = mem2chunk(mem);
-  hd = p->size;
+    p = mem2chunk(mem);
+    hd = p->size;
 
 #if HAVE_MMAP
-  if (hd & IS_MMAPPED)                       /* release mmapped memory. */
-  {
-    munmap_chunk(p);
-    return;
-  }
+    if (hd & IS_MMAPPED) {	/* release mmapped memory. */
+	munmap_chunk(p);
+	return;
+    }
 #endif
-  
-  check_inuse_chunk(p);
-  
-  sz = hd & ~PREV_INUSE;
-  next = chunk_at_offset(p, sz);
-  nextsz = chunksize(next);
-  
-  if (next == top)                            /* merge with top */
-  {
-    sz += nextsz;
 
-    if (!(hd & PREV_INUSE))                    /* consolidate backward */
-    {
-      prevsz = p->prev_size;
-      p = chunk_at_offset(p, -prevsz);
-      sz += prevsz;
-      unlink(p, bck, fwd);
+    check_inuse_chunk(p);
+
+    sz = hd & ~PREV_INUSE;
+    next = chunk_at_offset(p, sz);
+    nextsz = chunksize(next);
+
+    if (next == top) {		/* merge with top */
+	sz += nextsz;
+
+	if (!(hd & PREV_INUSE)) {	/* consolidate backward */
+	    prevsz = p->prev_size;
+	    p = chunk_at_offset(p, -prevsz);
+	    sz += prevsz;
+	    unlink(p, bck, fwd);
+	}
+
+	set_head(p, sz | PREV_INUSE);
+	top = p;
+	if ((unsigned long) (sz) >= (unsigned long) trim_threshold)
+	    malloc_trim(top_pad);
+	return;
     }
 
-    set_head(p, sz | PREV_INUSE);
-    top = p;
-    if ((unsigned long)(sz) >= (unsigned long)trim_threshold) 
-      malloc_trim(top_pad); 
-    return;
-  }
-
-  set_head(next, nextsz);                    /* clear inuse bit */
-
-  islr = 0;
-
-  if (!(hd & PREV_INUSE))                    /* consolidate backward */
-  {
-    prevsz = p->prev_size;
-    p = chunk_at_offset(p, -prevsz);
-    sz += prevsz;
-    
-    if (p->fd == last_remainder)             /* keep as last_remainder */
-      islr = 1;
-    else
-      unlink(p, bck, fwd);
-  }
-  
-  if (!(inuse_bit_at_offset(next, nextsz)))   /* consolidate forward */
-  {
-    sz += nextsz;
-    
-    if (!islr && next->fd == last_remainder)  /* re-insert last_remainder */
-    {
-      islr = 1;
-      link_last_remainder(p);   
+    set_head(next, nextsz);	/* clear inuse bit */
+
+    islr = 0;
+
+    if (!(hd & PREV_INUSE)) {	/* consolidate backward */
+	prevsz = p->prev_size;
+	p = chunk_at_offset(p, -prevsz);
+	sz += prevsz;
+
+	if (p->fd == last_remainder)	/* keep as last_remainder */
+	    islr = 1;
+	else
+	    unlink(p, bck, fwd);
     }
-    else
-      unlink(next, bck, fwd);
-  }
 
+    if (!(inuse_bit_at_offset(next, nextsz))) {	/* consolidate forward */
+	sz += nextsz;
 
-  set_head(p, sz | PREV_INUSE);
-  set_foot(p, sz);
-  if (!islr)
-    frontlink(p, sz, idx, bck, fwd);  
-}
+	if (!islr && next->fd == last_remainder) {	/* re-insert last_remainder */
+	    islr = 1;
+	    link_last_remainder(p);
+	} else
+	    unlink(next, bck, fwd);
+    }
 
 
+    set_head(p, sz | PREV_INUSE);
+    set_foot(p, sz);
+    if (!islr)
+	frontlink(p, sz, idx, bck, fwd);
+}
 
 
 
+
+
 /*
 
   Realloc algorithm:
